from rich.console import Console

DEFAULT_ARGS = {
    'path': './',
    'exts': 'py,cpp',
    'language': 'english',
    'model': 'gpt-3.5-turbo-16k-0613',
    'demand': 'No false summary is allowed',
    'out': 'readme.md',
    'cache': 1,
    'agree': False,
}

envs = dict(
    human_language="english",
    cache=None,
    root_path=None,
    gpt_model="gpt-3.5-turbo-16k-0613",
)
console = Console()
ext2language = {
    "py": "python",
    'cpp': "cpp",
    'c': "C",
    'json': "json",
    'md': "Markdown",
    'rs': "rust",
    "ts": "typescript",
    "js": "javascript",
    "tsx": "typescript",
    "jsx": "javascript",
}
scan_exts = []


def readme_header(args):
    command_args = vars(args)
    customize_args = {k: v for k, v in command_args.items() if v != DEFAULT_ARGS[k]}
    commandline = " ".join(
        [f"--{k} {v if k != 'agree' else ''}" for k, v in customize_args.items()]
    )
    return f"""
<div align="center">
    <a href="https://github.com/gusye1234/gpt-readme">
      <img src="https://img.shields.io/badge/written_by-GPT-green">
    </a>
    <a href="https://github.com/gusye1234/gpt-readme">
      <img src="https://img.shields.io/badge/could_be-Wrong-red">
    </a>
    <a href="https://pypi.org/project/gpt-readme/">
      <img src="https://img.shields.io/pypi/v/gpt-readme.svg">
    </a>
</div>

*This readme is generated by command: `gpt-readme {commandline}`*

"""
